//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "colors_unit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFrmColors *FrmColors;
//---------------------------------------------------------------------------
__fastcall TFrmColors::TFrmColors(TComponent* Owner)
    : TForm(Owner), accepted (false)
{
}
//---------------------------------------------------------------------------
bool __fastcall TFrmColors::invoke (agraph::colortable_t* ctbl)
{
    readFromCTbl (ctbl);

    accepted = false;

    Position = poMainFormCenter;

    ShowModal ();

    if (accepted)
        writeToCTbl (ctbl);

    return accepted;
}
void __fastcall TFrmColors::BtnCancelClick(TObject *Sender)
{
    Close ();    
}
//---------------------------------------------------------------------------
void __fastcall TFrmColors::BtnOKClick(TObject *Sender)
{
    accepted = true;
    Close ();
}
//---------------------------------------------------------------------------
void __fastcall TFrmColors::readFromCTbl (const agraph::colortable_t* ctbl)
{
    for (unsigned n = 0; n < 8; ++n)
        VleColors->Cells[1][n + 1]
            = AnsiString (static_cast <unsigned> (ctbl->rgbvals[n].rgbBlue));
}
void __fastcall TFrmColors::writeToCTbl (agraph::colortable_t* ctbl)
{
    for (unsigned n = 0; n < 8; ++n)
        ctbl->rgbvals[n].rgbBlue = ctbl->rgbvals[n].rgbGreen
            = ctbl->rgbvals[n].rgbRed = VleColors->Cells[1][n + 1].ToIntDef (0);
}
//---------------------------------------------------------------------------
void __fastcall TFrmColors::BtnDefaultClick(TObject *Sender)
{
    ucl::stl::ArrayPtr <agraph::colortable_t> ctbl
        (agraph::colortable_t::createColorTable (8));
    ctbl->setToDefault ();
    readFromCTbl (ctbl.get ());
}
//---------------------------------------------------------------------------

void __fastcall TFrmColors::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if (Key == VK_ESCAPE)
        Close ();     
}
//---------------------------------------------------------------------------

