//---------------------------------------------------------------------------

#ifndef main_unitH
#define main_unitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <XPMan.hpp>

#include "agsfile.hpp"
#include "gsconvert.hpp"
#include <ComCtrls.hpp>


#define UCL_DEFAULT_VCL_MESSAGE_MAP(base)                   \
    virtual void __fastcall Dispatch(void* Message)         \
    {                                                       \
        try                                                 \
        {                                                   \
            base::Dispatch (Message);                       \
        }                                                   \
        catch (const std::exception& e)                     \
        { /* distribute std exceptions as VCL exceptions */ \
            throw Exception (e.what ());                    \
        }                                                   \
        catch (const Exception& e)                          \
        {                                                   \
            throw;                                          \
        }                                                   \
        catch (...)                                         \
        {                                                   \
            throw Exception ("Unknown exception occured");  \
        }                                                   \
    }


//---------------------------------------------------------------------------
class TFrmMain : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
    TEdit *EdtFileName;
    TLabel *Label1;
    TButton *BtnFileOpen;
    TImage *ImgGrayscale;
    TGroupBox *GpbImage;
    TButton *BtnClose;
    TButton *BtnSaveBMP;
    TButton *BtnSaveAGS;
    TXPManifest *XPManifest;
    TSaveDialog *SvdAGSFile;
    TOpenPictureDialog *OpdFile;
    TSavePictureDialog *SvdBMPFile;
    TButton *Button1;
    TImage *ImgOriginal;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;
    TEdit *EdtContrast;
    TEdit *EdtBrightness;
    TLabel *Label5;
    TButton *BtnAdjustColors;
    TButton *BtnAdjustFactors;
    TUpDown *UpdContrast;
    TUpDown *UpdBrightness;
    TCheckBox *ChkFloydSteinberg;
    TLabel *Label6;
    TEdit *EdtPVFileName;
    TButton *BtnReset;
    void __fastcall BtnCloseClick(TObject *Sender);
    void __fastcall BtnFileOpenClick(TObject *Sender);
    void __fastcall BtnSaveBMPClick(TObject *Sender);
    void __fastcall BtnSaveAGSClick(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall UpdateGrayscaledFile(TObject *Sender);
    void __fastcall EdtPVFileNameChange(TObject *Sender);
    void __fastcall BtnResetClick(TObject *Sender);
    void __fastcall BtnAdjustFactorsClick(TObject *Sender);
    void __fastcall BtnAdjustColorsClick(TObject *Sender);
private:	// Benutzer-Deklarationen
    agraph::GSBitmap gcbm, gsbm;
    ucl::stl::ArrayPtr <agraph::colortable_t> ctbl;
    agraph::colortograyscalefactor_t cgsf;
    bool gs_loaded;

    apv::AGSFile agsfile;

    UCL_DEFAULT_VCL_MESSAGE_MAP (TForm)
public:		// Benutzer-Deklarationen
    __fastcall TFrmMain(TComponent* Owner);


};
//---------------------------------------------------------------------------
extern PACKAGE TFrmMain *FrmMain;
//---------------------------------------------------------------------------
#endif
