
/*
 *  ucl/bcc/multicastspec.hpp
 *
 *  Provides a few specializations for the ucl::asMulticast() function
 *  to ease its use.
 *  Author: Moritz Beutel
 *
 *  Specialized closure types:
 *  - void __fastcall (__closure* TNotifyEvent) (System::TObject*);
 */

#ifndef _UCL_MULTICASTSPEC_HPP
#define _UCL_MULTICASTSPEC_HPP

#include <ucl/bcc/multicast.hpp>


namespace ucl
{

namespace bcc
{

/// @cond UCL_SPECIALIZATION

    // TNotifyEvent
_UCL_MULTICAST_SPECIALIZE1 (ccFastcall, __fastcall, void, System::TObject*)

/// @endcond


} // namespace bcc

} // namespace ucl

#endif
