
/*
 *  ucl/stl/poddecl.hpp
 *
 *  POD declarations
 *  Author: Moritz Beutel
 */

#ifndef _UCL_PODDECL_HPP
#define _UCL_PODDECL_HPP



namespace ucl
{

namespace stl
{

template <typename T>
    struct IsPODType
{ enum { value = 0 }; };
template <typename T>
    struct IsPODType <T*>
{ enum { value = 1 }; };

template <> struct IsPODType <unsigned char>        { enum { value = 1 }; };
template <> struct IsPODType <signed char>          { enum { value = 1 }; };
template <> struct IsPODType <char>                 { enum { value = 1 }; };
template <> struct IsPODType <unsigned short>       { enum { value = 1 }; };
template <> struct IsPODType <signed short>         { enum { value = 1 }; };
template <> struct IsPODType <unsigned int>         { enum { value = 1 }; };
template <> struct IsPODType <signed int>           { enum { value = 1 }; };
template <> struct IsPODType <unsigned long>        { enum { value = 1 }; };
template <> struct IsPODType <signed long>          { enum { value = 1 }; };
template <> struct IsPODType <unsigned long long>   { enum { value = 1 }; };
template <> struct IsPODType <signed long long>     { enum { value = 1 }; };
template <> struct IsPODType <float>                { enum { value = 1 }; };
template <> struct IsPODType <double>               { enum { value = 1 }; };
template <> struct IsPODType <long double>          { enum { value = 1 }; };



} // namespace stl

} // namespace ucl


#endif // _UCL_PODDECL_HPP
