                             
/*
 *  ucl/stl/vclutils.hpp
 *
 *  Various VCL utilities
 *  Author: Moritz Beutel
 */

#ifndef _UCL_VCLUTILS_HPP
#define _UCL_VCLUTILS_HPP

#include <ucl/_debug.hpp>


#define UCL_BEGIN_VCL_MESSAGE_MAP                   \
    virtual void __fastcall Dispatch(void *Message) \
    {                                               \
       try                                          \
       {                                            \
          switch  (((PMessage)Message)->Msg)        \
          {

#ifdef UCL_DEBUG
 #include <typeinfo>

 #define UCL_END_VCL_MESSAGE_MAP(base)   default:          \
                       base::Dispatch(Message);            \
                       break;                              \
          }                                                \
       }                                                   \
       catch (const std::exception& e)                     \
       { /* distribute std exceptions as VCL exceptions */ \
           throw Sysutils::Exception (AnsiString           \
               (typeid (e).name ()) + ": " + e.what ());   \
       }                                                   \
       catch (const Sysutils::Exception& e)                \
       {                                                   \
           throw;                                          \
       }                                                   \
       catch (...)                                         \
       {                                                   \
           throw Sysutils::Exception                       \
               ("Unknown exception occured");              \
       }                                                   \
   }
#else
 #define UCL_END_VCL_MESSAGE_MAP(base)   default:          \
                       base::Dispatch(Message);            \
                       break;                              \
          }                                                \
       }                                                   \
       catch (const std::exception& e)                     \
       { /* distribute std exceptions as VCL exceptions */ \
           throw Sysutils::Exception (e.what ());          \
       }                                                   \
       catch (const Sysutils::Exception& e)                \
       {                                                   \
           throw;                                          \
       }                                                   \
       catch (...)                                         \
       {                                                   \
           throw Sysutils::Exception                       \
               ("Unknown exception occured");              \
       }                                                   \
   }
#endif


#define UCL_DEFAULT_VCL_MESSAGE_MAP(base)                  \
        UCL_BEGIN_VCL_MESSAGE_MAP                          \
        UCL_END_VCL_MESSAGE_MAP(base)


namespace ucl
{

namespace vcl
{


} // namespace vcl

} // namespace ucl


#endif // _UCL_VCLUTILS_HPP